/**
 * This file contains all the directives used by the @link IgxCalendarComponent.
 * Except for the directives which are used for templating the calendar itself
 * you should generally not use them directly.
 * @preferred
 */
import { ElementRef, EventEmitter, TemplateRef } from '@angular/core';
import { ICalendarDate, IgxCalendarBase } from './calendar';
/**
 * @hidden
 */
export declare class IgxCalendarYearDirective {
    calendar: IgxCalendarBase;
    value: Date;
    onYearSelection: EventEmitter<Date>;
    readonly defaultCSS: boolean;
    readonly currentCSS: boolean;
    readonly isCurrentYear: boolean;
    constructor(calendar: IgxCalendarBase);
    onClick(): void;
}
export declare class IgxCalendarMonthDirective {
    calendar: IgxCalendarBase;
    value: Date;
    index: any;
    onMonthSelection: EventEmitter<Date>;
    readonly defaultCSS: boolean;
    readonly currentCSS: boolean;
    readonly isCurrentMonth: boolean;
    constructor(calendar: IgxCalendarBase);
    onClick(): void;
}
export declare class IgxCalendarDateDirective {
    calendar: IgxCalendarBase;
    private elementRef;
    date: ICalendarDate;
    selected: boolean;
    onDateSelection: EventEmitter<ICalendarDate>;
    readonly isCurrentMonth: boolean;
    readonly isPreviousMonth: boolean;
    readonly isNextMonth: boolean;
    readonly nativeElement: any;
    readonly isInactive: boolean;
    readonly isToday: boolean;
    readonly isWeekend: boolean;
    readonly isDisabled: boolean;
    readonly isSpecial: boolean;
    tabindex: number;
    readonly defaultCSS: boolean;
    readonly isInactiveCSS: boolean;
    readonly isTodayCSS: boolean;
    readonly isSelectedCSS: boolean;
    readonly isWeekendCSS: boolean;
    readonly isDisabledCSS: boolean;
    readonly isSpecialCSS: boolean;
    private _selected;
    constructor(calendar: IgxCalendarBase, elementRef: ElementRef);
    onSelect(): void;
}
/**
 * @hidden
 */
export declare class IgxCalendarHeaderTemplateDirective {
    template: TemplateRef<any>;
    constructor(template: TemplateRef<any>);
}
/**
 * @hidden
 */
export declare class IgxCalendarSubheaderTemplateDirective {
    template: TemplateRef<any>;
    constructor(template: TemplateRef<any>);
}
